Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_DLList_Iterator Class Template Reference

A double-linked list container class iterator. More...

`#include <Containers_T.h>`

Inheritance diagram for ACE_DLList_Iterator:

[legend]
Collaboration diagram for ACE_DLList_Iterator:

[legend]
List of all members.

## Public Methods
| ACE_DLList_Iterator (ACE_DLList< T > &l)
void | reset (ACE_DLList< T > &l)
| Retasks the iterator to iterate over a new Double_Linked_List. More...
int | advance (void)
| Move forward by one element in the list. Returns 0 when all the items in the list have been seen, else 1. More...
int | next (T *&)
| Pass back the <next_item> that hasn't been seen in the list. Returns 0 when all items have been seen, else 1. More...
T * | next (void) const
int | remove (void)
| Removes the current item (i.e., <next>) from the list. Note that DLList iterators do not support <advance_and_remove> directly (defined in its base class) and you will need to release the element returned by it. More...
void | dump (void) const
| Delegates to ACE_Double_Linked_List_Iterator. More...
## Private Attributes
ACE_DLList< T > * | list_
## Friends
class | ACE_DLList< T >
class | ACE_DLList_Node

## Detailed Description

### template<class T>
class ACE_DLList_Iterator< T >

A double-linked list container class iterator.

This implementation uses ACE_Double_Linked_List_Iterator to perform the logic behind this container class. It delegates all of its calls to ACE_Double_Linked_List_Iterator.

## Constructor & Destructor Documentation

template<class T>
ACE_INLINE ACE_DLList_Iterator< T >::ACE_DLList_Iterator | ( | ACE_DLList< T > & | l | ) |

## Member Function Documentation

template<class T>
ACE_INLINE int ACE_DLList_Iterator< T >::advance | ( | void |  | ) |

| Move forward by one element in the list. Returns 0 when all the items in the list have been seen, else 1. Reimplemented from ACE_Double_Linked_List_Iterator.

template<class T>
ACE_INLINE void ACE_DLList_Iterator< T >::dump | ( | void |  | ) | const

| Delegates to ACE_Double_Linked_List_Iterator. Reimplemented from ACE_Double_Linked_List_Iterator.

template<class T>
ACE_INLINE T * ACE_DLList_Iterator< T >::next | ( | void |  | ) | const

| Deprecated: Delegates to ACE_Double_Linked_List_Iterator, except that whereas the Double_Linked_List version of next returns the node, this next returns the contents of the node Reimplemented from ACE_Double_Linked_List_Iterator_Base.

template<class T>
ACE_INLINE int ACE_DLList_Iterator< T >::next | ( | T *& | ptr | ) |

| Pass back the <next_item> that hasn't been seen in the list. Returns 0 when all items have been seen, else 1.

template<class T>
ACE_INLINE int ACE_DLList_Iterator< T >::remove | ( | void |  | ) |

| Removes the current item (i.e., <next>) from the list. Note that DLList iterators do not support <advance_and_remove> directly (defined in its base class) and you will need to release the element returned by it.

template<class T>
ACE_INLINE void ACE_DLList_Iterator< T >::reset | ( | ACE_DLList< T > & | l | ) |

| Retasks the iterator to iterate over a new Double_Linked_List. This allows clients to reuse an iterator without incurring the constructor overhead. If you do use this, be aware that if there are more than one reference to this iterator, the other "clients" may be very bothered when their iterator changes. @ Here be dragons. Comments?

## Friends And Related Function Documentation

template<class T>
friend class ACE_DLList< T >`[friend]`

template<class T>
friend class ACE_DLList_Node`[friend]`

## Member Data Documentation

template<class T>
ACE_DLList<T>* ACE_DLList_Iterator::list_`[private]`

The documentation for this class was generated from the following files:

- Containers_T.h
- Containers_T.i